<?php
/*
 #########################################################################
 #                       xt:Commerce Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2021 xt:Commerce GmbH All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # https://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Maximilianstrasse 9, 6020 Innsbruck
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */

defined('_VALID_CALL') or die('Direct Access is not allowed.');

require_once _SRV_WEBROOT . _SRV_WEB_PLUGINS. 'xt_mollie/classes/constants.php';


class callback_xt_mollie extends callback
{
    function process()
    {
        global $filter, $db, $tax, $countries, $xtLink, $store_handler, $customers_status, $xtPlugin;
        global $debug_ip;

        GLOBAL $ADODB_THROW_EXCEPTIONS;
        $ADODB_THROW_EXCEPTIONS = true;

        require_once _SRV_WEBROOT . _SRV_WEB_PLUGINS. 'xt_mollie/classes/class.xt_mollie.php';

        $delete_log_id = 0;
        $mollie_order = false;
        $xt_mollie = new xt_mollie();
        $log_data = [
            'callback_data' => ['mollie_order_id' => $_REQUEST['id']],
            'transaction_id' => $_REQUEST['id'],
            'class' => 'webhook_start',
        ];
        $delete_log_id = $xt_mollie->addCallbackLog($log_data);

        try
        {
            $mollie_order = $xt_mollie->getMollieOrder($_REQUEST['id']);

            $xt_mollie->setMollieOrderInXt($mollie_order, $mollie_order->metadata->xt_order_id, 'webhook', $delete_log_id, "xt-Bestellung {$mollie_order->metadata->xt_order_id}: Webhook Mollie Bestellung {$_REQUEST['id']} verarbeitet");
            $log_data = [
                'callback_data' => ['mollie_order_id' => $_REQUEST['id']],
                'transaction_id' => $_REQUEST['id'],
                'orders_id' => $mollie_order->metadata->xt_order_id,
                'class' => 'webhook_success'
            ];
            $xt_mollie->addCallbackLog($log_data);
        }
        catch(Exception $e)
        {
            xt_mollie::log(__FUNCTION__, "error in webhook for order {$_REQUEST['id']}", $mollie_order, $e);
            $log_data = [
                'callback_data' => $mollie_order,
                'transaction_id' => $_REQUEST['id'],
                'class' => 'webhook_error',
                'error_msg' => $e->getMessage(),
                'error_data' => $e->getTraceAsString()
            ];
            $xt_mollie->addCallbackLog($log_data);
        }
        finally
        {
            $db->Execute("DELETE FROM ".TABLE_CALLBACK_LOG." WHERE id = ?",[$delete_log_id]);
        }

        header("HTTP/1.1 200 OK");
        exit();
    }

}
