<?php
/*
 #########################################################################
 #                       xt:Commerce Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2021 xt:Commerce GmbH All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # https://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Maximilianstrasse 9, 6020 Innsbruck
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */


defined('_VALID_CALL') or die('Direct Access is not allowed.');

require_once _SRV_WEBROOT . _SRV_WEB_PLUGINS. 'xt_mollie/classes/class.xt_mollie.php';

global $price, $page, $info, $language, $store_handler, $currency, $language;

if (defined('XT_MOLLIE_MOL_ACTIVATED') && XT_MOLLIE_MOL_ACTIVATED)
{
    if (!empty($data) && $page->page_name == 'checkout' && ($page->page_action == 'payment' || $page->page_action == 'confirmation') && !empty($value) && !empty($plugin_payment_data))
    {
        if ($value['payment_code'] == 'xt_mollie')
        {
            static $mollie_testmode_warning_outputted = false;
            if (constant('_MOLLIE_TESTMODE') == 1 && !$mollie_testmode_warning_outputted)
            {
                $tplFile = 'warning-test-mode.tpl.html';
                $template = new Template();
                $template->getTemplatePath($tplFile, 'xt_mollie', '', 'plugin');
                $tpl_data_warn = array();
                $html = $template->getTemplate('', $tplFile, $tpl_data_warn);
                $info->_addInfo($html, 'error');
                $kp_testmode_warning_outputted = true;
            }

            $base_data = $data[$value['payment_code']];
            $payment_price = $price->_getPrice(array('price' => !empty($payment_price) ? $payment_price['plain'] : 0, 'tax_class' => $data['payment_tax_class'], 'curr' => true, 'format' => true, 'format_type' => 'default'));
            $payment_price['discount'] = !empty($payment_price) ? $payment_price->plain['discount'] : 0;
            $payment_price['fee_percent'] = !empty($payment_price) ? $payment_price['fee_percent'] : 0;
            $payment_price['percent'] = !empty($payment_price) ? $payment_price['percent'] : 0;
            $base_data['payment_price'] = $payment_price;

            unset($data[$value['payment_code']]);

            try
            {
                $options = [
                    'resource' => 'orders',
                    'locale' => $plugin_payment_data->getLocale($language->code),
                    'amount' => [
                        'currency' => $currency->code,
                        'value' => number_format($_SESSION["cart"]->total["plain"], 2, '.', '')
                    ],
                    'includeWallets' => 'applepay'
                ];

                $methods = $plugin_payment_data->getMollie()->methods->allActive($options);
                $_SESSION['mollie_payment_methods'] = $methods;
                //error_log(print_r($methods,true));

                $configured_pmcs = $plugin_payment_data->allowed_subpayments;

                $tmp_sub_data = [];

                $base_data['payment_price'] = $payment_price;

                foreach ($methods as $k => $pmc)
                {
                    if (!in_array($pmc->id, $configured_pmcs))
                    {
                        continue;
                    }
                    $tmp_sub_data[$pmc->id] = $base_data;
                    $tmp_sub_data[$pmc->id]['mollie_payment_method'] = $pmc->id;
                    $tmp_sub_data[$pmc->id]['payment_icon'] = htmlspecialchars($pmc->image->size2x);
                    $tmp_sub_data[$pmc->id]['payment_name'] = $pmc->description;
                }

                foreach ($configured_pmcs as $configured_pmc)
                {
                    if (key_exists($configured_pmc, $tmp_sub_data))
                    {
                        $data['xt_mollie' . '_' . $configured_pmc] = $tmp_sub_data[$configured_pmc];
                    }
                }


            } catch (\Mollie\Api\Exceptions\ApiException $e)
            {
                xt_mollie::log(__FILE__, "API call failed: " . htmlspecialchars($e->getMessage()), [], $e);
            }

        }
    }
}
